// complexitate: O(M*N^3*X)
#ifdef __BORLANDC__
#pragma option -3 -r -Z -O2
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MMAX 50
#define NMAX 20
#define RMAX 60

#ifndef __BORLANDC__
#define huge
#define _fmemset memset
#define _fmemcpy memcpy
#endif

short huge m[NMAX][NMAX][RMAX], l[NMAX][NMAX][RMAX], z[NMAX][RMAX], a[MMAX][NMAX];
int M, N, X, T, i, j, k, nr, s, v, Ans = 0;

int main(void)
{
    freopen("zidar.in", "r", stdin);
    freopen("zidar.out", "w", stdout);
    scanf("%d %d %d %d", &M, &N, &X, &T);
    for (i = 0; i < M; i++)
        for (j = 0; j < N; j++)
            scanf("%d", &a[i][j]);

    if (X > M*N) X = M*N;

    if (M > MMAX) fprintf(stderr, "M is out of range\n");
    if (N > NMAX) fprintf(stderr, "N is out of range\n");
    if (X > RMAX) fprintf(stderr, "R is out of range\n");

    _fmemset(m, 0xFF, sizeof(m));
    _fmemset(z, 0xFF, sizeof(z));

    for (i = 0; i < N; i ++)
        for (j = i; j < N && (v = j-i+1) <= X; j ++)
        {
            m[i][j][v] = j == i ? a[0][i] : m[i][j-1][v-1]+a[0][j];
            if (m[i][j][v] <= T && v > Ans)
                Ans = v;

            //update z
            for (k = i; k <= j; k ++)
                if (z[k][v] == -1 || z[k][v] > m[i][j][v])
                    z[k][v] = m[i][j][v];
        }

    for (int stp = 1; stp < M; stp ++)
    {
        _fmemcpy(l, m, sizeof(m));
        _fmemset(m, 0xFF, sizeof(m));

        for (i = 0; i < N; i ++)
            for (s = 0, j = i; j < N; j ++)
            {
                s += a[stp][j], v = j-i+1;
                for (nr = stp+v; nr <= N*stp+v && nr <= X; nr ++)
                {
                    //calculez m[i][j][nr]
                    for (k = i; k <= j; k ++)
                        if ((z[k][nr-v] != -1) && (m[i][j][nr] == -1 || m[i][j][nr] > z[k][nr-v]+s))
                        {
                            m[i][j][nr] = z[k][nr-v]+s;
                            if (m[i][j][nr] <= T && nr > Ans)
                                Ans = nr;
                        }
                }
            }

        //update z
        _fmemset(z, 0xFF, sizeof(z));

        for (i = 0; i < N; i ++)
            for (j = i; j < N; j ++)
            {
                v = j-i+1;
                for (nr = stp+v; nr <= N*stp+v && nr <= X; nr ++)
                    if (m[i][j][nr] != -1)
                    {
                        for (k = i; k <= j; k ++)
                            if (z[k][nr] == -1 || z[k][nr] > m[i][j][nr])
                                z[k][nr] = m[i][j][nr];
                    }
            }
    }

    printf("%d\n", Ans);
    return 0;
}
