/* mugurel andreica */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MMAX 2008

#define isAdjacent(x, y) (((c[x][0] == c[y][0]) || (c[x][0] == c[y][1]) || (c[x][1] == c[y][0]) || (c[x][1] == c[y][1])) ? 1 : 0)
#define isEqual(x, y) ((c[x][0] == c[y][0] && c[x][1] == c[y][1]) || (c[x][0] == c[y][1] && c[x][1] == c[y][0]))

char A[MMAX][MMAX], viz[MMAX];
int c[MMAX][2], q[MMAX];
int i, j, k, N, M, MM, cnt;

void nosol(void)
{
	fprintf(stderr, "no solution\n");

	printf("-1\n");
	exit(0);
}

void df(int x)
{
	int y;

	viz[x] = 1;
	q[++cnt] = x;

	for (y = 1; y <= M; y++)
		if (A[x][y] && !viz[y])
			df(y);
}

int processEdges(int idx, int nnodes)
{
	int m1, m2, m3, ii, jj, ok;

	if (idx > cnt)
		return nnodes;

	for (m1 = 1; m1 < idx; m1++)
		if (A[q[m1]][q[idx]])
			break;

	if (m1 >= idx)
	{
		fprintf(stderr, "edge %d/%d not adjacent to any previous edge!\n", idx, cnt);
		return 0;
	}

	for (ii = 0; ii < 2; ii++)
	{
		c[q[idx]][0] = c[q[m1]][ii];

		// try to fix the second endpoint

		c[q[idx]][1] = -1;
		ok = 1;

		for (m2 = 0; m2 < idx; m2++)
			if (m2 != m1 && !A[q[m2]][q[idx]] && isAdjacent(q[m2], q[idx]))
			{
				ok = 0;
				break;
			}

		if (!ok)
			continue;

		// let the second endpoint loose (equal to nnodes + 1)
		c[q[idx]][1] = nnodes + 1;

		for (m2 = 0; m2 < idx; m2++)
			if (A[q[m2]][q[idx]] != isAdjacent(q[m2], q[idx]))
			{
				ok = 0;
				break;
			}

		if (ok)
		{
			ok = processEdges(idx + 1, nnodes + 1);

			if (ok > 0)
				return ok;

			fprintf(stderr, "unsuccessful attempt at %d/%d\n", idx, cnt);
		}

		// the second endpoint must be one of the endpoints already selected

		for (m2 = 0; m2 < idx; m2++)
			if (m2 != m1 && A[q[m2]][q[idx]] && !isAdjacent(q[m2], q[idx]))
				break;

		if (m2 >= idx)
		{
			fprintf(stderr, "could not find an unsatisfied adjacent edge for %d/%d!\n", idx, cnt);
			continue;
		}

		for (jj = 0; jj < 2; jj++)

			if (c[q[m2]][jj] != c[q[idx]][0])

		{
			c[q[idx]][1] = c[q[m2]][jj];

			ok = 1;

			for (m3 = 0; m3 < idx; m3++)
				if ((A[q[m3]][q[idx]] != isAdjacent(q[m3], q[idx])) || isEqual(q[m3], q[idx]))
				{
					ok = 0;
					break;
				}

			if (!ok)
				continue;

			ok = processEdges(idx + 1, nnodes);

			if (ok > 0)
				return ok;

			fprintf(stderr, "unsuccessful attempt at %d/%d\n", idx, cnt);
		}
	}

	return 0;
}

int main()
{
	freopen("promo.in", "r", stdin);
	freopen("promo.out", "w", stdout);

	scanf("%d %d", &M, &MM);

	memset(A, 0, sizeof(A));

	for (k = 1; k <= MM; k++)
	{
		scanf("%d %d", &i, &j);
		A[i][j] = A[j][i] = 1;
	}

	memset(c, 0, sizeof(c));
	memset(viz, 0, sizeof(viz));

	N = 0;

	for (k = 1; k <= M; k++)
		if (!viz[k]) // a new connected component
		{
			cnt = 0;
			df(k);

			fprintf(stderr, "new connected component: %d\n", cnt);

			c[q[1]][0] = ++N;
			c[q[1]][1] = ++N;

			if (cnt >= 2)
			{
				c[q[2]][0] = N;
				c[q[2]][1] = ++N;
			}

			if (cnt >= 3)
			{
				N = processEdges(3, N);

				if (N <= 0)
					nosol();
			}
		}

	printf("%d\n", N);

	for (k = 1; k <= M; k++)
		printf("%d %d\n", c[k][0], c[k][1]);

	return 0;
}
