/* radu lupsa */
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

const int max_dim=1000001;

int rola[max_dim];
int banda[max_dim];
bool invers[max_dim];
int n;
FILE* fo;

void bug(const char* msg)
{
	fprintf(stderr, "BUG! : %s\n", msg);
	exit(2);
}

void wrong(const char* msg)
{
	fprintf(stderr, "wrong: %s\n", msg);
	exit(1);
}

void citeste()
{
	int i;
	FILE* fi=fopen("role.in", "r");
	if(fi==0) bug("cannot open input file");
	fscanf(fi, "%d", &n);
	for(i=0 ; i<=n ; ++i){
		rola[i]=0;
	}
	for(i=1 ; i<=n ; ++i){
		int v, inv;
		fscanf(fi, "%d %d", &v, &inv);
		if(v<0 || v>n) bug("valoare afara din domeniu");
		if(rola[v]!=0) bug("doua benzi pe aceeasi rola");
		invers[i]=(inv==1);
		banda[i]=v;
		rola[v]=i;
	}
	for(i=0 ; i<=n ; ++i){
		if(rola[i]==0) banda[0]=i;
	}
	fclose(fi);
}

void muta(int x)
{
	fprintf(fo, "%d\n", x);
	int y=banda[0];
	assert(rola[y]==0);
	assert(banda[rola[x]]==x);
	if(rola[x]==0) wrong("a fost indicata rola vida");
	banda[rola[x]]=y;
	banda[0]=x;
	invers[rola[x]]=!invers[rola[x]];
	rola[y]=rola[x];
	rola[x]=0;
}

void elimina_inverse()
{
	for(int i=1 ; i<n ; ++i){
		if(banda[i]==i && invers[i]){
			muta(i);
		}
	}
}

void lipeste_cicluri()
{
	bool* mark=new bool[n+1];
	int i, j, k;
	for(i=0 ; i<=n ; ++i){
		mark[i]=false;
	}
	i=0;
	do {
		i=rola[i];
		mark[i]=true;
	} while(i!=0);
	for(i=1 ; i<=n ; ++i){
		if(banda[i]==i && !invers[i]) mark[i]=true;
		if(!mark[i]){
			j=i;
			k=i;
			do {
				j=rola[j];
				if(!invers[j]) k=j;
				mark[j]=true;
			} while(j!=i);
			muta(banda[k]);
		}
	}
}

void finish()
{
	while(rola[0]!=0) {
		int x=banda[0];
		if(invers[x]){
			muta(banda[x]);
		} else {
			int y=banda[x];
			while(y!=0 && invers[y]) y=banda[y];
			if(y!=0){
				muta(banda[y]);
				muta(banda[x]);
			} else {
				fclose(fo);
				fo=fopen("role.out", "w");
				fprintf(fo, "-1\n");
				return;
			}
		}
	}
}

int main()
{
	citeste();
	fo=fopen("role.out","wt");
	elimina_inverse();
	lipeste_cicluri();
	finish();
	fclose(fo);
	return 0;
}

